let wasm;
const { TextDecoder } = require(String.raw`util`);

let WASM_VECTOR_LEN = 0;

let cachegetNodeBufferMemory = null;
function getNodeBufferMemory() {
    if (cachegetNodeBufferMemory === null || cachegetNodeBufferMemory.buffer !== wasm.memory.buffer) {
        cachegetNodeBufferMemory = Buffer.from(wasm.memory.buffer);
    }
    return cachegetNodeBufferMemory;
}

function passStringToWasm(arg) {

    const size = Buffer.byteLength(arg);
    const ptr = wasm.__wbindgen_malloc(size);
    getNodeBufferMemory().write(arg, ptr, size);
    WASM_VECTOR_LEN = size;
    return ptr;
}

let cachegetInt32Memory = null;
function getInt32Memory() {
    if (cachegetInt32Memory === null || cachegetInt32Memory.buffer !== wasm.memory.buffer) {
        cachegetInt32Memory = new Int32Array(wasm.memory.buffer);
    }
    return cachegetInt32Memory;
}

let cachedTextDecoder = new TextDecoder('utf-8');

let cachegetUint8Memory = null;
function getUint8Memory() {
    if (cachegetUint8Memory === null || cachegetUint8Memory.buffer !== wasm.memory.buffer) {
        cachegetUint8Memory = new Uint8Array(wasm.memory.buffer);
    }
    return cachegetUint8Memory;
}

function getStringFromWasm(ptr, len) {
    return cachedTextDecoder.decode(getUint8Memory().subarray(ptr, ptr + len));
}
/**
* @param {string} name
* @returns {string}
*/
module.exports.greet = function(name) {
    const retptr = 8;
    const ret = wasm.greet(retptr, passStringToWasm(name), WASM_VECTOR_LEN);
    const memi32 = getInt32Memory();
    const v0 = getStringFromWasm(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1]).slice();
    wasm.__wbindgen_free(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1] * 1);
    return v0;
};

/**
* @param {string} policy_str
* @returns {string}
*/
module.exports.policy_to_miniscript = function(policy_str) {
    const retptr = 8;
    const ret = wasm.policy_to_miniscript(retptr, passStringToWasm(policy_str), WASM_VECTOR_LEN);
    const memi32 = getInt32Memory();
    const v0 = getStringFromWasm(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1]).slice();
    wasm.__wbindgen_free(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1] * 1);
    return v0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {number}
*/
module.exports.script_size = function(script, script_type, pk_type) {
    const ret = wasm.script_size(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret >>> 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {number}
*/
module.exports.max_satisfaction_witness_elements = function(script, script_type, pk_type) {
    const ret = wasm.max_satisfaction_witness_elements(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret >>> 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {string}
*/
module.exports.to_script = function(script, script_type, pk_type) {
    const retptr = 8;
    const ret = wasm.to_script(retptr, passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    const memi32 = getInt32Memory();
    const v0 = getStringFromWasm(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1]).slice();
    wasm.__wbindgen_free(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1] * 1);
    return v0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {string}
*/
module.exports.normalized = function(script, script_type, pk_type) {
    const retptr = 8;
    const ret = wasm.normalized(retptr, passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    const memi32 = getInt32Memory();
    const v0 = getStringFromWasm(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1]).slice();
    wasm.__wbindgen_free(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1] * 1);
    return v0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {boolean}
*/
module.exports.is_trivial = function(script, script_type, pk_type) {
    const ret = wasm.is_trivial(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret !== 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {boolean}
*/
module.exports.is_unsatisfiable = function(script, script_type, pk_type) {
    const ret = wasm.is_unsatisfiable(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret !== 0;
};

const heap = new Array(32);

heap.fill(undefined);

heap.push(undefined, null, true, false);

function getObject(idx) { return heap[idx]; }

let heap_next = heap.length;

function dropObject(idx) {
    if (idx < 36) return;
    heap[idx] = heap_next;
    heap_next = idx;
}

function takeObject(idx) {
    const ret = getObject(idx);
    dropObject(idx);
    return ret;
}
/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {any}
*/
module.exports.relative_timelocks = function(script, script_type, pk_type) {
    const ret = wasm.relative_timelocks(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return takeObject(ret);
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @param {number} time
* @returns {string}
*/
module.exports.at_age = function(script, script_type, pk_type, time) {
    const retptr = 8;
    const ret = wasm.at_age(retptr, passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN, time);
    const memi32 = getInt32Memory();
    const v0 = getStringFromWasm(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1]).slice();
    wasm.__wbindgen_free(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1] * 1);
    return v0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {number}
*/
module.exports.n_keys = function(script, script_type, pk_type) {
    const ret = wasm.n_keys(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret >>> 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {number}
*/
module.exports.minimum_n_keys = function(script, script_type, pk_type) {
    const ret = wasm.minimum_n_keys(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret >>> 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {string}
*/
module.exports.sorted = function(script, script_type, pk_type) {
    const retptr = 8;
    const ret = wasm.sorted(retptr, passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    const memi32 = getInt32Memory();
    const v0 = getStringFromWasm(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1]).slice();
    wasm.__wbindgen_free(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1] * 1);
    return v0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {number}
*/
module.exports.len = function(script, script_type, pk_type) {
    const ret = wasm.len(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret >>> 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {boolean}
*/
module.exports.is_empty = function(script, script_type, pk_type) {
    const ret = wasm.is_empty(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret !== 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {any}
*/
module.exports.to_bytes = function(script, script_type, pk_type) {
    const ret = wasm.to_bytes(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return takeObject(ret);
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {string}
*/
module.exports.to_p2sh = function(script, script_type, pk_type) {
    const retptr = 8;
    const ret = wasm.to_p2sh(retptr, passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    const memi32 = getInt32Memory();
    const v0 = getStringFromWasm(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1]).slice();
    wasm.__wbindgen_free(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1] * 1);
    return v0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {string}
*/
module.exports.to_v0_p2wsh = function(script, script_type, pk_type) {
    const retptr = 8;
    const ret = wasm.to_v0_p2wsh(retptr, passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    const memi32 = getInt32Memory();
    const v0 = getStringFromWasm(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1]).slice();
    wasm.__wbindgen_free(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1] * 1);
    return v0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {boolean}
*/
module.exports.is_p2sh = function(script, script_type, pk_type) {
    const ret = wasm.is_p2sh(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret !== 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {boolean}
*/
module.exports.is_p2pkh = function(script, script_type, pk_type) {
    const ret = wasm.is_p2pkh(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret !== 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {boolean}
*/
module.exports.is_p2pk = function(script, script_type, pk_type) {
    const ret = wasm.is_p2pk(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret !== 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {boolean}
*/
module.exports.is_witness_program = function(script, script_type, pk_type) {
    const ret = wasm.is_witness_program(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret !== 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {boolean}
*/
module.exports.is_v0_p2wsh = function(script, script_type, pk_type) {
    const ret = wasm.is_v0_p2wsh(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret !== 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {boolean}
*/
module.exports.is_v0_p2wpkh = function(script, script_type, pk_type) {
    const ret = wasm.is_v0_p2wpkh(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret !== 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {boolean}
*/
module.exports.is_op_return = function(script, script_type, pk_type) {
    const ret = wasm.is_op_return(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret !== 0;
};

/**
* @param {string} script
* @param {string} script_type
* @param {string} pk_type
* @returns {boolean}
*/
module.exports.is_provably_unspendable = function(script, script_type, pk_type) {
    const ret = wasm.is_provably_unspendable(passStringToWasm(script), WASM_VECTOR_LEN, passStringToWasm(script_type), WASM_VECTOR_LEN, passStringToWasm(pk_type), WASM_VECTOR_LEN);
    return ret !== 0;
};

function addHeapObject(obj) {
    if (heap_next === heap.length) heap.push(heap.length + 1);
    const idx = heap_next;
    heap_next = heap[idx];

    heap[idx] = obj;
    return idx;
}

module.exports.__wbindgen_json_parse = function(arg0, arg1) {
    const ret = JSON.parse(getStringFromWasm(arg0, arg1));
    return addHeapObject(ret);
};

module.exports.__wbindgen_throw = function(arg0, arg1) {
    throw new Error(getStringFromWasm(arg0, arg1));
};
wasm = require('./miniscript_js_bg');

